from .nodes import Node
from typing import Any, Dict, List, Tuple


class BaseConstructor:
    def construct_mapping(self, node: Node, deep: bool=False) -> Dict[str, Any]: ...
    def construct_pairs(self, node: Node) -> List[Tuple[str, object]]: ...
    def get_single_data(self) -> Dict[str, Any]: ...
    def get_data(self) -> Dict[str, Any]: ...


class SafeConstructor(BaseConstructor): ...


class Constructor(SafeConstructor): ...
